//+------------------------------------------------------------------+
//|                              USDJPY H4 Bank of Japan forever.mq4 |
//+------------------------------------------------------------------+
extern int          cPeriod      = 1;
extern int          cImpulse     = 634.8;
extern int          cBarsInGame  = 1;
int PreviousTime;
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   int total = OrdersTotal();
   for (int i = 0; i < total; i++) 
      {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == 17)
         {
         int shift = iBarShift(Symbol(),Period(),OrderOpenTime());
         if (shift>=cBarsInGame)
            {
            if (OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,0); 
               else OrderClose(OrderTicket(),OrderLots(),Bid,0);
            }
         }      
      }
//----
   if (Time[0] == PreviousTime) return;
   PreviousTime = Time[0];
//----
   double prevHi = High[1 + cPeriod];
   double prevLo = Low[1 + cPeriod];
   double Hi = High[cPeriod];
   double Lo = Low[cPeriod];
   double Impulse = Open[0] - Open[0 + cPeriod];
   double maxHi = iHigh(Symbol(),Period(),iHighest(Symbol(),Period(),MODE_HIGH, cPeriod, 1));
   double minLo = iLow(Symbol(),Period(),iLowest(Symbol(),Period(),MODE_LOW, cPeriod, 1));
//----
   if (prevLo > Lo && Lo <= minLo && Impulse > cImpulse * Point) OrderSend(Symbol(), OP_SELL, 0.1, Bid,0, 0, 0, "", 17, 0, Red);
   else if (prevHi < Hi && Hi >= maxHi && -Impulse > cImpulse * Point) OrderSend(Symbol(), OP_BUY, 0.1, Ask, 0, 0, 0, "", 17, 0, Blue); 
//----
   return;
  }


